From 709950aa334abe571d5b811160ddf9c63b9a88cd Mon Sep 17 00:00:00 2001
From: David Rader <davidr@openscg.com>
Date: Fri, 29 Apr 2016 11:02:52 -0400
Subject: [PATCH] Add BigSQL packages to downloads pages

---
 templates/pages/download/linux/linux_openscg.inc | 23 +++++++++++++-------
 templates/pages/download/macosx.html             | 20 +++++++++++++++++-
 templates/pages/download/windows.html            | 27 ++++++++++++++++++++++--
 3 files changed, 59 insertions(+), 11 deletions(-)

diff --git a/templates/pages/download/linux/linux_openscg.inc b/templates/pages/download/linux/linux_openscg.inc
index b63509c..55d8102 100644
--- a/templates/pages/download/linux/linux_openscg.inc
+++ b/templates/pages/download/linux/linux_openscg.inc
@@ -1,18 +1,25 @@
 <h2>Cross distribution packages</h2>
 <p>
-Generic RPM and DEB packages that provide a server-only distribution
-are avaliable for some 32 and 64-bit Linux distributions.  These
-packages provide a single set of binaries and consistent packaging
-across different Linux distributions.  They are designed for server
-installation where a GUI is not available and consistency across
-multiple distributions is a requirement.
+<a href="http://www.bigsql.org/se/postgresql/installers.jsp">Download</a>
+the packages from BigSQL for all supported versions.
 </p>
 <p>
-<a href="http://www.openscg.com/se/postgresql/packages.jsp">Download</a>
-the packages from OpenSCG for all supported versions.
+Generic RPM and DEB packages that provide a server-only distribution are
+available for 64-bit Linux distributions. These packages provide a single set
+of binaries and consistent packaging across different Linux distributions.
+They are designed for server installation where consistency across multiple
+distributions is a requirement.
 </p>
 
 <p>
 <i>Note:</i> The cross distribution packages do not fully integrate with
 the platform-specific packaging systems.
 </p>
+
+<p>
+This distribution is also available in a
+<a href="http://www.bigsql.org/se/postgresql/sandboxes.jsp">sandbox</a> version,
+with command line and graphical tools for managing databases and multiple
+community packages. It is designed for advanced users and for embedding with
+other products.
+</p>
diff --git a/templates/pages/download/macosx.html b/templates/pages/download/macosx.html
index 306f00f..462afe6 100644
--- a/templates/pages/download/macosx.html
+++ b/templates/pages/download/macosx.html
@@ -17,7 +17,7 @@ There are several other installers available for PostgreSQL on Mac OS X,
 which is the recommended way to install.
 </p>
 
-<h2>Graphical installer</h2>
+<h2>Graphical installer by EnterpriseDB</h2>
 
 <p>
 An installer is available for Mac OS X that includes PostgreSQL,
@@ -32,6 +32,24 @@ Mac OS X 10.6 and above on 32 and 64-bit Intel CPUs.
 the installer from EnterpriseDB for all supported versions.
 </p>
 
+<h2>Graphical installer by BigSQL</h2>
+
+<p>
+<a href="http://www.bigsql.org/se/postgresql/installers.jsp">Download</a> the
+installer from BigSQL for all supported versions.
+</p>
+
+<p>
+This distribution includes the PostgreSQL server, a graphical installer, command
+line and graphical tools for managing databases and packages, plus dozens of
+pre-integrated open source community components, all built with a 100% open
+source toolchain. The distribution is consistent across Mac OS X, Windows, and
+Linux. It is also available in a
+<a href="http://www.bigsql.org/se/postgresql/sandboxes.jsp">developer sandbox</a>
+version, good for advanced users and for embedding with other applications.
+</p>
+
+
 <h2>Postgres.app</h2>
 <p>
 <a href="http://postgresapp.com">Postgres.app</a> is a simple, native Mac OS X app that runs in the menubar without the need of an installer. Open the app, and you have a PostgreSQL server 
diff --git a/templates/pages/download/windows.html b/templates/pages/download/windows.html
index 8064cf1..08aa65c 100644
--- a/templates/pages/download/windows.html
+++ b/templates/pages/download/windows.html
@@ -4,10 +4,10 @@
 
 <h1>Windows installers</h1>
 
-<h2>Graphical installer</h2>
+<h2>Graphical installer by EnterpriseDB</h2>
 
 <p>
-The graphical installer for PostgreSQL includes the PostgreSQL server,
+This graphical installer for PostgreSQL includes the PostgreSQL server,
 <a href="http://www.pgadmin.org">pgAdmin III</a>; a graphical tool
 for managing and developing your databases, and StackBuilder; a
 package manager that can be used to download and install additional
@@ -32,4 +32,27 @@ installations, it is intended for users who wish to include PostgreSQL as
 part of another application installer.
 </p>
 
+<h2>Graphical installer by BigSQL</h2>
+
+<p>
+<a href="http://www.bigsql.org/se/postgresql/installers.jsp">Download</a> the installer from BigSQL for all supported versions.
+</p>
+<p>
+This distribution includes the PostgreSQL server, a graphical installer, command line and graphical tools for managing databases and packages, plus dozens of pre-integrated open source community components, all built with a 100% open source toolchain. Capabilities include:
+</p>
+<ul>
+	<li>High availability, replication, security, and backup/restore
+	<li>Provisioning, management, and monitoring
+	<li>Web and desktop developer tools, and geospatial capability
+	<li>Database compatibility and migration tools
+	<li>Foreign data wrappers including Oracle, Cassandra, Hadoop, and others
+	<li>Procedural languages including Python, Perl, Java, TCL, and others
+</ul>
+<p>
+This distribution is consistent across Windows, Mac OS X, and Linux, and is a fast, developer-friendly way to get a complete PostgreSQL environment installed and running, regardless of your technical environment.
+</p>
+<p>
+This distribution is also available in a <a href="http://www.bigsql.org/se/postgresql/sandboxes.jsp">developer sandbox</a> version, good for advanced users and for embedding with other applications.
+</p>
+
 {%endblock%}
-- 
2.6.4 (Apple Git-63)