diff --git a/src/bin/initdb/t/001_initdb.pl b/src/bin/initdb/t/001_initdb.pl
index 8cf762a..372865d 100644
--- a/src/bin/initdb/t/001_initdb.pl
+++ b/src/bin/initdb/t/001_initdb.pl
@@ -31,7 +31,7 @@ command_fails(
 
 command_fails(
 	[ 'initdb', '-U', 'pg_test', $datadir ],
-	'role names cannot being with "pg_"');
+	'role names cannot begin with "pg_"');
 
 mkdir $datadir;
 command_ok([ 'initdb', '-N', '-T', 'german', '-X', $xlogdir, $datadir ],