diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index 6421c86..3230417 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -830,7 +830,9 @@ PostmasterMain(int argc, char *argv[])
 		 * permission is handled because the user is reading inside the data
 		 * dir
 		 */
-		puts(GetConfigOption(output_config_variable, false, false));
+		const char *config = GetConfigOption(output_config_variable,
+											 false, false);
+		puts(config ? config : "(null)");
 		ExitPostmaster(0);
 	}
 